function [Dataset_PRC TrainedMapping] = GeneratePRToolsDataset(DirectoryNameLoad,TrainOrTest)

filelistLoad=dir(fullfile(DirectoryNameLoad,'*.mat'));
NoOfFeatures=3;
load(fullfile(DirectoryNameLoad,filelistLoad(1,1).name))
NoOfFrames=min(NoOfFrames,size(filelist,1)-2);
Data=zeros(NoOfFrames*size(filelistLoad,1),NoOfFeatures);
Labels=zeros(NoOfFrames*size(filelistLoad,1),1);
LabelsChar=zeros(NoOfFrames*size(filelistLoad,1),1);
LabelsChar=char(LabelsChar);
for k=1:1:size(filelistLoad,1)
    %load mat file
    load(fullfile(DirectoryNameLoad,filelistLoad(k,1).name))
    NoOfFrames=min(NoOfFrames,size(filelist,1)-2);
    %Data consists of M*K matrix, with M data points in K feature
    %dimensions
    Data((k-1)*NoOfFrames+1:(k)*NoOfFrames,1)=CoverageChange(RandomStartFrame:1:RandomStartFrame+NoOfFrames-1);
    Data((k-1)*NoOfFrames+1:(k)*NoOfFrames,2)=DivergenceHighValuedRatio(RandomStartFrame:1:RandomStartFrame+NoOfFrames-1);
%     Data((k-1)*NoOfFrames+1:(k)*NoOfFrames,3)=DivergenceMean_InlierOutlierRatio(RandomStartFrame:1:RandomStartFrame+NoOfFrames-1);
    Data((k-1)*NoOfFrames+1:(k)*NoOfFrames,3)=InlierRatioWhole(RandomStartFrame:1:RandomStartFrame+NoOfFrames-1);
%     Data((k-1)*NoOfFrames+1:(k)*NoOfFrames,5)=FundamentalMatrixVariation(RandomStartFrame:1:RandomStartFrame+NoOfFrames-1);
    
    %Labels for classifier
    if SpecularDiffuseLabel==0
        LabelChar='Diffuse';
    else
        LabelChar='Specular';
    end
    Labels((k-1)*NoOfFrames+1:(k)*NoOfFrames,1)=repmat(SpecularDiffuseLabel,NoOfFrames,1);
%     LabelsChar((k-1)*NoOfFrames+1:(k)*NoOfFrames,1)=repmat(LabelChar,NoOfFrames,1);
end

Dataset_PRC=dataset(Data,Labels);
Dataset_PRC = setfeatlab(Dataset_PRC,strvcat('CoverageChange', 'Divergence_HighRatio',  'InlierRatio'));

if strcmp(TrainOrTest,'Train')
%     W = {ldc,qdc}; % Define set of untrained classifiers
    W = {ldc,qdc,knnc,parzenc}; % Define set of untrained classifiers
    TrainedMapping = Dataset_PRC*W;
%     [TrainSet,TestSet] = gendat(Dataset_PRC,0.8); % Generate 50% for training and 50% for testing
%     V = TrainSet*W; % Train them all and construct classifiers
%     D = TestSet*V; % Test them by C
%     E = D*testc; % Store classification errors
else
    TrainedMapping=[];
end
