function [AngleMotion,MM]=MotionOpticalFlow3(DirectoryName, FileType, SpecularDiffuseLabel)

filelist=dir(fullfile(DirectoryName,strcat('*.', FileType)));
%Load parameters from an m file
Parameters_MotionOpticalFlow;
%Randomize the starting frame
if NoOfFrames<size(filelist,1)
    RandomPermutation=randperm(size(filelist,1)-2-NoOfFrames);
    RandomStartFrame=RandomPermutation(1);
else
    RandomStartFrame=1;
end

%Start the frame loop
for i=RandomStartFrame:1:RandomStartFrame-1+min(NoOfFrames,size(filelist,1)-2) %size(filelist,1)-4

    %Read images
    if length(size(imread(fullfile(DirectoryName,filelist(i,1).name))))==3
        I1 = rgb2gray(imread(fullfile(DirectoryName,filelist(i,1).name)));
        I2 = rgb2gray(imread(fullfile(DirectoryName,filelist(i+1,1).name)));
        I3 = rgb2gray(imread(fullfile(DirectoryName,filelist(i+2,1).name)));
    else
        I1 = (imread(fullfile(DirectoryName,filelist(i,1).name)));
        I2 = (imread(fullfile(DirectoryName,filelist(i+1,1).name)));
        I3 = (imread(fullfile(DirectoryName,filelist(i+2,1).name)));
    end
    
    SizeGrid=size(I1);
    
    %create a sequence of images for optical flow
    SequenceImages(:,:,1)=I1;
    SequenceImages(:,:,2)=I2;
    
    [sy sx st] = size(SequenceImages);
    
    %Compute optical flow
    O = optical_flow (double(SequenceImages), gx, thres_lin, nc_min);
    clear SequenceImages
    
    O2=O;
    %NaN entries are replaced with zeros
    O2(isnan(O))=0;
    %Discriminate zero and nonzero entries in the optical flow
    ZeroEntries=find(O2==0);
    NonZeroEntries=find(not(O2==0));
    
    %Motion direction and magnitude computation for each flow vector
    AngleMotion=180*atan2(squeeze(O2(:,:,1)),squeeze(O2(:,:,2)))/pi;
    %AM=find(not(AngleMotion==0));
    
  %  hist(AngleMotion)
     MotionMagnitude=sqrt(squeeze(O2(:,:,1)).^2+squeeze(O2(:,:,2)).^2);
     MM=find(not(MotionMagnitude==0));
%     %Wrap around 
    AngleMotion(AngleMotion>-180 & AngleMotion<-150)= -1 * AngleMotion(AngleMotion>-180 & AngleMotion<-150);
     AngleMotion(AngleMotion<0 & AngleMotion>-30)= -1 * AngleMotion(AngleMotion<0 & AngleMotion>-30);
     MotionDirectionAngles{i}=AngleMotion;
     AM=find(not(AngleMotion==0));
     AngleMotion=AngleMotion(AM);
    %Std of motion direction angle
    StdMotionDirection(i)=std(AngleMotion(:));

    
%     clear FeatureImag1 FeatureImag2 InlierFlow OutlierFlow
%     %RANSAC epipolar constraint applied on optical flow displacements
%     O2_Nonzero=O2(NonZeroEntries);
%     StdO2=std(O2_Nonzero);
%     %Select flow field points in an interval
%     OpticalFlowThreshInterval=[StdInterval(1)*StdO2 StdInterval(2)*StdO2];
%     [ISub, JSub]=find( (abs(O2(:,:,1))>OpticalFlowThreshInterval(1) & abs(O2(:,:,1))<OpticalFlowThreshInterval(2)) | (abs(O2(:,:,2))>OpticalFlowThreshInterval(1) & abs(O2(:,:,2))<OpticalFlowThreshInterval(2)));
%     FeatureImag1=[ISub'; JSub';ones(1,length(ISub))];
%     FeatureImag2=zeros(3,length(FeatureImag1));
%     for j=1:1:length(ISub)
%         FeatureImag2(1,j)=FeatureImag1(1,j)+O2(ISub(j),JSub(j),1);
%         FeatureImag2(2,j)=FeatureImag1(2,j)+O2(ISub(j),JSub(j),2);
%         FeatureImag2(3,j)=1;
%     end
%     SumFeatureImg1=sum(FeatureImag1);
%     SumFeatureImg2=sum(FeatureImag2);
%     FeatureImag1(:,SumFeatureImg1==0 | SumFeatureImg2==0)=[];
%     FeatureImag2(:,SumFeatureImg1==0 | SumFeatureImg2==0)=[];
% 
%     %Batch by batch analysis  should be done due to memory limitations
%     NoOfEpipolarBatches=ceil(size(FeatureImag1,2)/BatchSize);
%     RandSelection=randperm(size(FeatureImag1,2));
%     InlierFlow=[];
%     OutlierFlow=[];
%     FeatureImage1_Inlier=[];
%     FeatureImage2_Inlier=[];
%     F_inlier=[];
%     for j=1:1:NoOfEpipolarBatches
%         RandomBatch=RandSelection((j-1)*BatchSize+1:min(j*BatchSize,size(FeatureImag1,2)));
%         FeatureImag1_batch=FeatureImag1(:,RandomBatch);
%         FeatureImag2_batch=FeatureImag2(:,RandomBatch);
%         [inlier F_inlier(:,:,j)] = ransac_epipolar_constraint_outputF( FeatureImag1_batch, FeatureImag2_batch, RansacIteration, RansacThreshold );
%         InlierFlow=cat(2,InlierFlow,RandomBatch(inlier));
%         OutlierFlow=cat(2,OutlierFlow,RandomBatch(not(inlier)));
%         FeatureImage1_Inlier=cat(2,FeatureImage1_Inlier,FeatureImag1_batch(:,inlier));
%         FeatureImage2_Inlier=cat(2,FeatureImage2_Inlier,FeatureImag2_batch(:,inlier));
%     end
%     InlierRatioWhole(i)=size(FeatureImage1_Inlier,2)/size(FeatureImag1,2);
%     FundamentalMatrixVariation(i)=sum(sum(std(F_inlier,[],3)));
%     
%     %Divergence computation
%     UFlowGrid=O2(:,:,1);
%     VFlowGrid=O2(:,:,2);
%     [XFlowGrid,YFlowGrid] = meshgrid(1:SizeGrid(2),1:SizeGrid(1));
%     DivMotionField = divergence(XFlowGrid,YFlowGrid,UFlowGrid,VFlowGrid);
%     DivMotionField(isnan(DivMotionField))=0;
%     
%     clear DivMotionField_Inlier AngleMotion_Inlier DivMotionField_Outlier AngleMotion_Outlier
%     %Inlier and outlier computations done separately
%     for j=1:1:length(ISub)
%         DivMotionField_Inlier(j)=DivMotionField(ISub(j),JSub(j));
%         AngleMotion_Inlier(j)=AngleMotion(ISub(j),JSub(j));
%     end
%     DivMotionField_Inlier=DivMotionField_Inlier(InlierFlow);
%     AngleMotion_Inlier=AngleMotion_Inlier(InlierFlow);
%     DivergenceMean_Inlier(i)=mean(abs(DivMotionField_Inlier));
%     DivergenceStd_Inlier(i)=std(abs(DivMotionField_Inlier));
%     AngleMotionStd_Inlier(i)=std((AngleMotion_Inlier));
%     for j=1:1:length(ISub)
%         DivMotionField_Outlier(j)=DivMotionField(ISub(j),JSub(j));
%         AngleMotion_Outlier(j)=AngleMotion(ISub(j),JSub(j));
%     end
%     DivMotionField_Outlier=DivMotionField_Outlier(OutlierFlow);
%     AngleMotion_Outlier=AngleMotion_Outlier(OutlierFlow);
%     DivergenceMean_Outlier(i)=mean(abs(DivMotionField_Outlier));
%     DivergenceStd_Outlier(i)=std(abs(DivMotionField_Outlier));
%     AngleMotionStd_Outlier(i)=std((AngleMotion_Outlier));
%     DivergenceMean_InlierOutlierRatio(i)=DivergenceMean_Inlier(i)/DivergenceMean_Outlier(i);
%     DivergenceStd_InlierOutlierRatio(i)=DivergenceStd_Inlier(i)/DivergenceStd_Outlier(i);
%     AngleMotionStd_InlierOutlierRatio(i)=AngleMotionStd_Inlier(i)/AngleMotionStd_Outlier(i);
%     
%     %Non zero divergence is used for statistical analysis
%     DivNonzero=abs(DivMotionField);
%     DivNonzero=DivNonzero(:);
%     DivNonzero(DivNonzero<DivergenceRejectionThresh)=[];
%     DivergenceMean(i)=mean(DivNonzero);
%     DivergenceStd(i)=std(DivNonzero);
%     DivergenceHighValuedRatio(i)=length(find(DivNonzero>DivergenceHighValuedThres))/length(NonZeroEntries);
%     
%     offset = ceil(9.31648319*sqrt(log(100)));   % Point where Gaussian envelope drops to 10%
%     [Vx Vy] = vis_flow_oy (O(:,:,1), O(:,:,2), gx, offset, 1, 'm');
%     if (gx==0)
%         jmp = 1;
%     else
%         jmp = floor(sx/gx);
%         jmp = jmp + (jmp==0);
%     end
%     nv = length(offset+1:jmp:(sy-offset))*length(offset+1:jmp:(sx-offset));
%     %Coverage analysis
%     Coverage(i)=sum(sum(~isnan(Vx)))/nv*100;
%     
%     %Coverage change computed with increasing and decreasing number of
%     %sequence frames. So the same analysis is done for a larger sequence to
%     %the optical flow computation
%     SequenceImages2(:,:,1)=I1;
%     SequenceImages2(:,:,2)=I2;
%     SequenceImages2(:,:,3)=I3;
% %     SequenceImages2(:,:,4)=I4;
% %     SequenceImages2(:,:,5)=I5;
%     [sy2 sx2 st2] = size(SequenceImages2);
%     O_b = optical_flow (double(SequenceImages2), gx, thres_lin, nc_min);
%     clear SequenceImages2
%     O2_b=O_b;
%     O2_b(isnan(O_b))=0;
%     NonZeroEntries=find(not(O2_b==0));
%     
%     clear FeatureImag1 FeatureImag2 InlierFlow OutlierFlow
%     %RANSAC epipolar constraint applied on optical flow displacements
%     O2_Nonzero=O2_b(NonZeroEntries);
%     StdO2=std(O2_Nonzero);
%     OpticalFlowThreshInterval=[StdInterval(1)*StdO2 StdInterval(2)*StdO2];
%     [ISub, JSub]=find( (abs(O2_b(:,:,1))>OpticalFlowThreshInterval(1) & abs(O2_b(:,:,1))<OpticalFlowThreshInterval(2)) | (abs(O2_b(:,:,2))>OpticalFlowThreshInterval(1) & abs(O2_b(:,:,2))<OpticalFlowThreshInterval(2)));
%     FeatureImag1=[ISub'; JSub';ones(1,length(ISub))];
%     FeatureImag2=zeros(3,length(FeatureImag1));
%     for j=1:1:length(ISub)
%         FeatureImag2(1,j)=FeatureImag1(1,j)+O2_b(ISub(j),JSub(j),1);
%         FeatureImag2(2,j)=FeatureImag1(2,j)+O2_b(ISub(j),JSub(j),2);
%         FeatureImag2(3,j)=1;
%     end
%     SumFeatureImg1=sum(FeatureImag1);
%     SumFeatureImg2=sum(FeatureImag2);
%     FeatureImag1(:,SumFeatureImg1==0 | SumFeatureImg2==0)=[];
%     FeatureImag2(:,SumFeatureImg1==0 | SumFeatureImg2==0)=[];
% 
%     %Batch by batch analysis  should be done due to memory limitations   
%     NoOfEpipolarBatches=ceil(size(FeatureImag1,2)/BatchSize);
%     RandSelection=randperm(size(FeatureImag1,2));
%     InlierFlow=[];
%     OutlierFlow=[];
%     FeatureImage1_Inlier=[];
%     FeatureImage2_Inlier=[];
%     F_inlier=[];
%     for j=1:1:NoOfEpipolarBatches
%         RandomBatch=RandSelection((j-1)*BatchSize+1:min(j*BatchSize,size(FeatureImag1,2)));
%         FeatureImag1_batch=FeatureImag1(:,RandomBatch);
%         FeatureImag2_batch=FeatureImag2(:,RandomBatch);
%         [inlier F_inlier(:,:,j)] = ransac_epipolar_constraint_outputF( FeatureImag1_batch, FeatureImag2_batch, RansacIteration, RansacThreshold );
%         InlierFlow=cat(2,InlierFlow,RandomBatch(inlier));
%         OutlierFlow=cat(2,OutlierFlow,RandomBatch(not(inlier)));
%         FeatureImage1_Inlier=cat(2,FeatureImage1_Inlier,FeatureImag1_batch(:,inlier));
%         FeatureImage2_Inlier=cat(2,FeatureImage2_Inlier,FeatureImag2_batch(:,inlier));
%     end
%     InlierRatioWhole_b(i)=size(FeatureImage1_Inlier,2)/size(FeatureImag1,2);
%     FundamentalMatrixVariation_b(i)=sum(sum(std(F_inlier,[],3)));
%     
%     %Divergence computation
%     UFlowGrid=O2_b(:,:,1);
%     VFlowGrid=O2_b(:,:,2);
%     DivMotionField_b = divergence(XFlowGrid,YFlowGrid,UFlowGrid,VFlowGrid);
%     NonZeroEntries=find(not(O2_b==0));
%     DivMotionField_b(isnan(DivMotionField_b))=0;
%     
%     MotionMagnitude_b=sqrt(squeeze(O2_b(:,:,1)).^2+squeeze(O2_b(:,:,2)).^2);
%     
%     clear DivMotionField_Inlier AngleMotion_Inlier DivMotionField_Outlier AngleMotion_Outlier
%     for j=1:1:length(ISub)
%         DivMotionField_Inlier(j)=DivMotionField(ISub(j),JSub(j));
%         AngleMotion_Inlier(j)=AngleMotion(ISub(j),JSub(j));
%     end
%     DivMotionField_Inlier=DivMotionField_Inlier(InlierFlow);
%     AngleMotion_Inlier=AngleMotion_Inlier(InlierFlow);
%     DivergenceMean_Inlier_b(i)=mean(abs(DivMotionField_Inlier));
%     DivergenceStd_Inlier_b(i)=std(abs(DivMotionField_Inlier));
%     AngleMotionStd_Inlier_b(i)=std((AngleMotion_Inlier));
%     for j=1:1:length(ISub)
%         DivMotionField_Outlier(j)=DivMotionField(ISub(j),JSub(j));
%         AngleMotion_Outlier(j)=AngleMotion(ISub(j),JSub(j));
%     end
%     DivMotionField_Outlier=DivMotionField_Outlier(OutlierFlow);
%     AngleMotion_Outlier=AngleMotion_Outlier(OutlierFlow);
%     DivergenceMean_Outlier_b(i)=mean(abs(DivMotionField_Outlier));
%     DivergenceStd_Outlier_b(i)=std(abs(DivMotionField_Outlier));
%     AngleMotionStd_Outlier_b(i)=std((AngleMotion_Outlier));
%     DivergenceMean_InlierOutlierRatio_b(i)=DivergenceMean_Inlier_b(i)/DivergenceMean_Outlier_b(i);
%     DivergenceStd_InlierOutlierRatio_b(i)=DivergenceStd_Inlier_b(i)/DivergenceStd_Outlier_b(i);
%     AngleMotionStd_InlierOutlierRatio_b(i)=AngleMotionStd_Inlier_b(i)/AngleMotionStd_Outlier_b(i);
% 
%     %Non zero divergence is used for statistical analysis
%     DivNonzero=abs(DivMotionField_b);
%     DivNonzero=DivNonzero(:);
%     DivNonzero(DivNonzero<DivergenceRejectionThresh)=[];
%     DivergenceMean_b(i)=mean(DivNonzero);
%     DivergenceStd_b(i)=std(DivNonzero);
%     DivergenceMean_Seq(i)=DivergenceMean_b(i)/DivergenceMean(i);
%     DivergenceStd_Seq(i)=DivergenceStd_b(i)/DivergenceStd(i);
%     
%     DivergenceHighValuedRatio_b(i)=length(find(DivNonzero>DivergenceHighValuedThres))/length(NonZeroEntries);
%     
% 
%     [Vx2 Vy2] = vis_flow_oy (O_b(:,:,1), O_b(:,:,2), gx, offset, 1, 'm');
%     nv2 = length(offset+1:jmp:(sy2-offset))*length(offset+1:jmp:(sx2-offset));
%     Coverage2(i)=sum(sum(~isnan(Vx2)))/nv2*100;
%     CoverageChange(i)=Coverage(i)-Coverage2(i);
%     ZeroedFlow=O2_b-O2;
%     
% %     figure, imagesc(abs(DivMotionField)), hold, [Vx Vy] = vis_flow (O(:,:,1), O(:,:,2), gx, offset, 1, 'm');
% %     figure, imagesc(AngularVelocity), hold, [Vx Vy] = vis_flow (O(:,:,1), O(:,:,2), gx, offset, 1, 'm');
% %     figure, imagesc(AngularVelocity_b), hold, [Vx Vy] = vis_flow (O_b(:,:,1), O_b(:,:,2), gx, offset, 1, 'm');
%   
%     display('End Frame')
 end
% cd(DirectoryName)
% DateTime=clock;
% save(strcat('OpticalFlowData_',int2str(DateTime(1)),int2str(DateTime(2)),int2str(DateTime(3)),int2str(DateTime(4)),int2str(DateTime(5)),int2str(DateTime(6))))
